
#include <unistd.h>
#include <stdio.h>
#include "typedefs.h"
#include "globals.h"
#include <ghttp.h>
#include <string.h>
#include <sys/stat.h>
#include <libgnomeui/libgnomeui.h>

int get_file(char **file, int *len)

{
  int ret;
  FILE *testfile;
  struct stat teststat;
  ghttp_request *request;
  GtkWidget * mbox;
  char message[1024];

  if (cpager.offline) {		/* offline mode - use local file */
				/* for testing only */
    
    testfile = fopen("score.txt", "r");
    if (testfile == NULL) {
      perror("score.txt");
      return (-1);
    }

    if (fstat(fileno(testfile), &teststat) < 0) {
      perror("stat score.txt");
      return(-1);
    }

    *len = teststat.st_size;
    *file = malloc(*len * sizeof(char));
    ret = fread(*file, *len, 1, testfile);
    //    printf("file size = %d\n", *len);
    return 0;
  }
				/* else use URL mode */

  
   /* This is the http request object */
   request = NULL;
   /* Allocate a new empty request object */
   request = ghttp_request_new();
   /* Set the URI for the request object */
   ghttp_set_uri(request, "http://livechat.rediff.com:80/sports/score/score.txt");
   /* Close the connection after you are done. */
   ghttp_set_header(request, http_hdr_Connection, "close");
   /* Prepare the connection */
   ret = ghttp_prepare(request);

  /* Process the request */
    ret = ghttp_process(request);
    if (ret < 0) {
      if (cpager.error_shown == 0) {

	gdk_threads_enter ();
	
	sprintf(message, "%s\n\nNnetwork errors will not be shown again in this session\n", ghttp_get_error(request));
	mbox = gnome_message_box_new (message,
                                GNOME_MESSAGE_BOX_ERROR,
                                GNOME_STOCK_BUTTON_OK, 
                                NULL);
  
	gtk_widget_show (mbox);
	
	gdk_threads_leave ();	
	cpager.error_shown = 1;
      }
	
      //     printf("%s\n", ghttp_get_error(request));
     return -1;
    }

   *len = ghttp_get_body_len(request);
   //   printf("length of file is %d\n", *len);   
   
   *file = malloc(*len);
   memcpy(*file, ghttp_get_body(request), *len);
   
   /* Write out the body. Note that the body of the request may not be
   null terminated so we have to be careful of the length. */
/*     fwrite(ghttp_get_body(request), ghttp_get_body_len(request), 1, */
/*     stdout); */

   
   /* Destroy the request. This closes any file descriptors that may be
   open and will free any memory associated with the request. */
   ghttp_request_destroy(request);
   return 0;
}


int get_data(match_t *data)
{
  char *file;
  int len;
  int ret;
  char *pos1, *pos2, *tmp;
  int i;
  
  if ((ret = get_file(&file, &len)) != 0) {
    //    printf("no data\n");
    return (-1);
  }

  tmp = file;

  // Warning: code depends on match_t being of 5 equal strings
  for (i=0; i<5; i++) {
  pos1 = strchr(tmp, '=')+1;
  pos2 = strchr(tmp, '\n')+1;

  if (strncmp(tmp, "l1", 2) == 0) {
    strncpy( data->l1, pos1, pos2-pos1);
    *( data->l1 + (pos2-pos1-1)) = '\0';
  }

  else if (strncmp(tmp, "l2", 2) == 0) {
    strncpy( data->l2, pos1, pos2-pos1);
    *( data->l2 + (pos2-pos1-1)) = '\0';
  }

  else if (strncmp(tmp, "message", 7) == 0) {
    strncpy( data->msg, pos1, pos2-pos1);
    *( data->msg + (pos2-pos1-1)) = '\0';
  }

  tmp = pos2;  
  
/*    strncpy((char *) data + i*BUF, pos1, pos2-pos1); */
/*    *((char *) data + i*BUF + (pos2-pos1-1)) = '\0'; */
  }

  // printf("new data...\n");

/*    printf("l1=<%s>\nl2=<%s>\nadv=<%s>\nadvurl=<%s>\nmsg=<%s>\n", */
/*  	 data->l1, */
/*  	 data->l2, */
/*  	 data->adv, */
/*  	 data->advurl, */
/*  	 data->msg); */


  return 0;
}


