
#include <gnome.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include "typedefs.h"
#include "globals.h"
#include "back.xpm"
#include "logo.xpm"
#include <pthread.h>
#include <libgnomeui/libgnomeui.h>
#include <errno.h>
#include <sys/time.h>

#define PROG "Scoreboard"
#define VERSION "0.8"

static void
display_expose(GtkWidget *widget, GdkEventExpose *event, gpointer data);


/*  int */
/*  btn_pressed() */
/*  { */
/*    return TRUE; */

/*  } */

int
refresh_btn_pressed ()
{

  pthread_mutex_lock(&refresh_mutex);
  pthread_cond_broadcast(&refresh_cond);
  pthread_mutex_unlock(&refresh_mutex);
  
}

GtkWidget *create_setting (void);

int
setting_btn_pressed()
{
  GtkWidget * mbox;
  
  //  cpager.setting_widget = create_setting ();

  mbox = gnome_message_box_new ("Sorry... Proxy support and other options are not implemented in this version of Scoreboard",
                                GNOME_MESSAGE_BOX_ERROR,
                                GNOME_STOCK_BUTTON_OK, 
                                NULL);
  
  gtk_widget_show (mbox);
  

  //printf("Proxy support not implemented in this version...\n");
  
  return TRUE;

}

void iconify_btn_pressed(void)
{
        Window xwindow;

        if (!cpager.main_window->window) return;
        xwindow = GDK_WINDOW_XWINDOW(cpager.main_window->window);
        XIconifyWindow (GDK_DISPLAY (), xwindow, DefaultScreen (GDK_DISPLAY ()));
}



int
exit_btn_pressed ()
{
  gtk_main_quit();
}


GtkWidget *create_about1(void);

static gint
about_btn_pressed()
{

  cpager.about = create_about1();
  gtk_widget_show(cpager.about);
  
  return TRUE;
}

GtkWidget *create_setting ()
{
  //  GtkWidget

}


static void display_motion(GtkWidget *w, GdkEventMotion *event, gpointer data)
{
	gint i;
	gint x = (gint)event->x;
	gint y = (gint)event->y;

	// printf("motion:%d x %d\n", x, y);

	if (cpager.display_in_move)
		{
		GdkModifierType modmask;
		gint px, py;
		gdk_window_get_pointer (NULL, &px, &py, &modmask);
		px -= cpager.display_press_x;
		py -= cpager.display_press_y;
		
		gdk_window_move (cpager.main_window->window, px, py);
		return;

		}
}

static void display_pressed(GtkWidget *w, GdkEventButton *event, gpointer data)
{
	GdkModifierType modmask;
	gint i;
	gint x = (gint)event->x;
	gint y = (gint)event->y;
	//	printf("pressed:%d x %d\n", x, y);

	if (event->button == 3)
	  {
	    gtk_menu_popup (GTK_MENU(cpager.main_menu), NULL, NULL, NULL, NULL,
			    event->button, event->time);
	    return;
	  }
	
	cpager.display_in_move = TRUE;
	gdk_window_get_pointer (NULL, &cpager.display_press_root_x,
				&cpager.display_press_root_y,
				&cpager.modmask);
	
	cpager.display_press_x = x;
	cpager.display_press_y = y;
	
	cpager.display_in_press = TRUE;
}


static void display_released(GtkWidget *w, GdkEventButton *event, gpointer data)
{
	gint x = (gint)event->x;
	gint y = (gint)event->y;
	GdkModifierType modmask;
	gint px;
	gint py;
	
	//	printf("released:%d x %d\n", x, y);
	gdk_window_get_pointer (NULL, &px, &py, &modmask);
	if (px == cpager.display_press_root_x
	    && py == cpager.display_press_root_y)
	  {
	    gdk_window_raise (cpager.main_window->window);
	  }

	cpager.display_in_press = FALSE;
	cpager.display_in_move = FALSE;

}

void display_events_init(GtkWidget *display)
{
  //  GtkWidget *display;

  //  display = cpager.drawing_area;
  
  gtk_widget_set_events (display,
			 GDK_ENTER_NOTIFY_MASK | GDK_LEAVE_NOTIFY_MASK
			 | GDK_POINTER_MOTION_MASK | GDK_BUTTON_PRESS_MASK
			 | GDK_BUTTON_RELEASE_MASK);
  
  gtk_signal_connect(GTK_OBJECT(display),"motion_notify_event",
		     (GtkSignalFunc) display_motion, NULL);
  
  gtk_signal_connect(GTK_OBJECT(display),"button_press_event",
		     (GtkSignalFunc) display_pressed, NULL);
  
  gtk_signal_connect(GTK_OBJECT(display),"button_release_event",
		     (GtkSignalFunc) display_released, NULL);
  
/*    gtk_signal_connect(GTK_OBJECT(display),"leave_notify_event", */
/*  		     (GtkSignalFunc) display_leave, NULL); */

  cpager.display_in_press = FALSE;
  cpager.display_in_move = FALSE;

  /* the expose event */
  gtk_signal_connect(GTK_OBJECT(display),"expose_event",
		     (GtkSignalFunc) display_expose, NULL);
  //  gtk_signal_connect(GTK_OBJECT(mainwindow),"configure_event",(GtkSignalFunc) display_move, NULL);

}


GtkWidget *create_main_menu(void)
{
	GtkWidget *menu;
	GtkWidget *submenu;
	GtkWidget *load_menu;
	GtkWidget *toggle_menu;
	GtkWidget *song_menu;
	GtkWidget *button;

	menu = gtk_menu_new();

	button = gtk_menu_item_new_with_label("Refresh");
	gtk_signal_connect (GTK_OBJECT (button), "activate",(GtkSignalFunc) refresh_btn_pressed, NULL);
	gtk_menu_append(GTK_MENU(menu), button);
	gtk_widget_show(button);

	button = gtk_menu_item_new();
	gtk_menu_append(GTK_MENU(menu),button);
	gtk_widget_show(button);

	button = gtk_menu_item_new_with_label("Settings");
	gtk_signal_connect (GTK_OBJECT (button), "activate",(GtkSignalFunc) setting_btn_pressed, NULL);
	gtk_menu_append(GTK_MENU(menu),button);
	gtk_widget_show(button);

        button = gtk_menu_item_new();
        gtk_menu_append(GTK_MENU(menu),button);
        gtk_widget_show(button);

	button = gtk_menu_item_new_with_label("About");
	gtk_signal_connect (GTK_OBJECT (button), "activate",(GtkSignalFunc) about_btn_pressed, NULL);
	gtk_menu_append(GTK_MENU(menu),button);
	gtk_widget_show(button);

        button = gtk_menu_item_new();
        gtk_menu_append(GTK_MENU(menu),button);
        gtk_widget_show(button);

	button = gtk_menu_item_new_with_label("Iconify");
	gtk_signal_connect (GTK_OBJECT (button), "activate",(GtkSignalFunc) iconify_btn_pressed, NULL);
	gtk_menu_append(GTK_MENU(menu),button);
	gtk_widget_show(button);

        button = gtk_menu_item_new();
        gtk_menu_append(GTK_MENU(menu),button);
        gtk_widget_show(button);

	button = gtk_menu_item_new_with_label("Exit");
	gtk_signal_connect (GTK_OBJECT (button), "activate",(GtkSignalFunc) exit_btn_pressed, NULL);
	gtk_menu_append(GTK_MENU(menu),button);
	gtk_widget_show(button);

	

	return menu;

}


GtkWidget*
create_about1 (void)
{
  const gchar *authors[] = {
    "Lokesh Setia <lsetia@users.sourceforge.net>",
    NULL
  };
  GtkWidget *about1;

  about1 = gnome_about_new (PROG, VERSION,
                        "Distributed under GNU Public License",
                        authors,
                        "Cricket Pager is a utility to display real time scores of a cricket match.  It picks up it's data from a Rediff server. Disclaimer: This program is (as of this writing) not endorsed or sponsored by Rediff.com in any way",
                        NULL);
  gtk_object_set_data (GTK_OBJECT (about1), "about1", about1);
  gtk_window_set_modal (GTK_WINDOW (about1), TRUE);

  return about1;
}


void *
update_data_thread(void *dummy)
{

  match_t match_data;
  int ret;
  struct timeval now;
  struct timespec timeout;
  

  for ( ; ; ) {

    ret = get_data(&match_data);
    if (ret == 0) /* no error occured */
      {
	
	strncpy(cpager.l1, match_data.l1, BUF);
	strncpy(cpager.l2, match_data.l2, BUF);
	strncpy(cpager.msg, match_data.msg, BUF);

      }

    gdk_threads_enter ();
    gtk_widget_queue_draw(cpager.main_window);
    gdk_threads_leave ();

    gettimeofday(&now, NULL);
    timeout.tv_sec = now.tv_sec + cpager.sleep;
    timeout.tv_nsec = now.tv_usec * 1000;
    
    pthread_mutex_lock(&refresh_mutex);
    ret = pthread_cond_timedwait(&refresh_cond, &refresh_mutex, &timeout);
    pthread_mutex_unlock(&refresh_mutex);

    if (ret == ETIMEDOUT)
      ; // printf("Timed out, normal refresh\n");
    else
      ; //printf("Hmmm... Looks like you pressed refresh\n");

  }
  
}
    

#if 0 /* buzz code not currently working */
void *
buzz (void *dummy)
{

  int posx, posy;
  int ctr;
  #define BUZZ 50

  for (;;) {
    sleep(1);
  printf("in buzz...\n");
  
  gdk_window_get_position(cpager.main_window->window,
			  &posx, &posy);

  for (ctr=0; ctr< 5; ctr++) {
    gdk_window_move( cpager.main_window->window, posx-50+(ctr*10), posy );
    //    while (gtk_main_iteration());        
    usleep(BUZZ * 1000);


    //    gtk_widget_set_uposition( cpager.main_window, posx, posy );
    //    usleep(BUZZ * 1000);    
    gdk_window_move( cpager.main_window->window, posx+50-(ctr*10), posy );
    while (gtk_main_iteration());    
    usleep(BUZZ * 1000);



    
/*      while (gtk_events_pending()) */
/*        gtk_main_iteration(); */
    

  }

  //  gtk_widget_set_uposition( cpager.main_window, posx, posy );
  gdk_window_move( cpager.main_window->window, posx, posy );      


  }
  
  return;
  
}

#endif


static void
display_expose(GtkWidget *widget, GdkEventExpose *event, gpointer data)
{
        GdkPixmap *pixmap;
	GtkWidget *display_area;
	int posx, posy;

        pixmap = cpager.back_pixmap;
	
	display_area = cpager.drawing_area;
	
	if (!pixmap) return;

/*  	printf("Expose called for x=%d, y=%d, width=%d, height=%d\n", */
/*  	       (gint)event->area.x, (gint)event->area.y, */
/*  	       (gint)event->area.width, (gint)event->area.height); */

	gdk_window_get_position(cpager.main_window->window,
				&posx, &posy);

        gdk_draw_pixmap(display_area->window,
			display_area->style->fg_gc[GTK_WIDGET_STATE(display_area)],
                        pixmap,
                        (gint)event->area.x, (gint)event->area.y,
                        (gint)event->area.x, (gint)event->area.y,
                        (gint)event->area.width, (gint)event->area.height);

	if (! cpager.font) {
	  printf("Invalid font!\n");
	  return;
	}
	
	gdk_draw_string(display_area->window,
			cpager.font,
			widget->style->black_gc,
			20, 45, cpager.l1);
	
	gdk_draw_string(display_area->window,
			cpager.font,
			widget->style->black_gc,
			20, 65, cpager.l2);

	gtk_tooltips_set_tip(cpager.tooltip, cpager.drawing_area,
			     cpager.msg, NULL);
  
	

}



void
create_initial_windows()
{

  GtkStyle *style;
  GtkWidget *fixed;
  GtkWidget *button;
  GdkCursor *hand_cursor;
  GdkPixmap *icon_pixmap;

  //  GtkWidget ad_label;
  pthread_t buzz_thread;
  pthread_t update_thread;

  cpager.main_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  
  gtk_window_set_title(GTK_WINDOW (cpager.main_window), "Cricket Pager");
  gtk_window_set_wmclass(GTK_WINDOW (cpager.main_window),
			 "cpager5", "cpager5");

  gtk_widget_realize(cpager.main_window);  

  gdk_window_set_decorations (cpager.main_window->window, 0);

  fixed = gtk_fixed_new();
  button = gtk_button_new_with_label("Click");
  gtk_widget_show(button);
  
  cpager.drawing_area = gtk_drawing_area_new ();
  gtk_drawing_area_size (GTK_DRAWING_AREA (cpager.drawing_area),
			 128, 96);
  gtk_widget_set_extension_events (cpager.drawing_area,
				   GDK_EXTENSION_EVENTS_CURSOR);  

  gtk_widget_show (cpager.drawing_area);

  hand_cursor = gdk_cursor_new(GDK_HAND1);


  #define FONT "-b&h-lucidatypewriter-medium-r-normal-*-*-80-*-*-m-*-*-*"
  //  cpager.font = gdk_font_load ("-adobe-helvetica-medium-r-normal-*-*-100-*-*-p-*-iso8859-1");
  cpager.font = gdk_font_load (FONT);


  /* Signals used to handle backing pixmap */
  display_events_init(cpager.drawing_area);

  style = gtk_widget_get_default_style();
  gtk_widget_set_usize(cpager.main_window, 128, 96);
  gtk_widget_set_usize(fixed, 128, 96);
  
  cpager.back_pixmap =
    gdk_pixmap_create_from_xpm_d (cpager.main_window->window,
				   &cpager.mask_pixmap,
				   &style->bg[GTK_STATE_NORMAL],
				   back_xpm);

  icon_pixmap =
    gdk_pixmap_create_from_xpm_d (cpager.main_window->window,
				   &cpager.icon_mask_pixmap,
				   &style->bg[GTK_STATE_NORMAL],
				   logo_xpm);

  
  /* a pixmap widget to contain the pixmap */
  cpager.gtk_back_pixmap = gtk_pixmap_new( cpager.back_pixmap, cpager.mask_pixmap );

  gtk_widget_show( cpager.gtk_back_pixmap);


  gtk_fixed_put(GTK_FIXED (fixed), GTK_WIDGET (cpager.drawing_area), 0, 0);
  //  gtk_fixed_put(GTK_FIXED (fixed), GTK_WIDGET (button), 10, 60);  
  gtk_container_add( GTK_CONTAINER(cpager.main_window),
		     GTK_WIDGET (fixed) );

  gtk_widget_set_uposition( cpager.main_window,
			    gdk_screen_width()-160,
			    50 );  
  gtk_widget_show( GTK_WIDGET (fixed));
  gtk_widget_show_all (cpager.main_window);

  cpager.main_menu = create_main_menu();

  gdk_window_set_icon(cpager.main_window->window, NULL,
		      icon_pixmap,
		      cpager.icon_mask_pixmap);
  

  gdk_window_set_cursor(cpager.drawing_area->window, hand_cursor);  
  cpager.tooltip = gtk_tooltips_new();

  
  gnome_win_hints_init ();
  if (gnome_win_hints_wm_exists ()) {
    
    gnome_win_hints_set_state (cpager.main_window,
			       WIN_STATE_STICKY);

    gnome_win_hints_set_layer(cpager.main_window,
			      WIN_LAYER_ONTOP);
    
    gnome_win_hints_set_hints (cpager.main_window,
			       WIN_HINTS_SKIP_FOCUS | WIN_HINTS_SKIP_WINLIST |
			       WIN_HINTS_SKIP_TASKBAR);

  }
  

  gtk_widget_shape_combine_mask(cpager.main_window, cpager.mask_pixmap, 0, 0);


  //   pthread_create(&buzz_thread, NULL, buzz, NULL);
  pthread_create(&update_thread, NULL, update_data_thread, NULL);  


}


void
initialize()
{

  cpager.sleep = 60;
  cpager.offline = 0;
  cpager.error_shown = 0;
  strncpy(cpager.l1, "Connecting...", BUF);
  strncpy(cpager.l2, "", BUF);
  strncpy(cpager.msg, "No information yet", BUF);
  
}
  
  
int
main (int argc, char *argv[])
{


  g_thread_init(NULL);
  initialize();
  
  /* initialize gtk */
  gnome_init (PROG, VERSION, argc, argv);  
  //  gtk_init (&argc, &argv);

  create_initial_windows();

  gtk_main ();

  return 0; /* never reached */
}
  
